> For the complete documentation index, see [llms.txt](https://docs.stormbit.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stormbit.finance/developers/building-hooks.md).

# Building Hooks

Hooks add custom logic at protocol events.

```solidity
interface IHooks {
    // Term events
    function beforeTermInitialize(address caller, TermKey memory termKey, bytes calldata hookData) external;
    function afterTermInitialize(address caller, TermKey memory termKey, bytes calldata hookData) external;
    function beforeTermModifyPosition(address caller, TermKey memory termKey, TermModifyPositionParams memory params, bytes calldata hookData) external;
    function afterTermModifyPosition(address caller, TermKey memory termKey, TermModifyPositionParams memory params, bytes calldata hookData) external;
    function beforeTermSettle(address caller, TermKey memory termKey, TermSettleParams memory params, bytes calldata hookData) external;
    function afterTermSettle(address caller, TermKey memory termKey, TermSettleParams memory params, bytes calldata hookData) external;

    // Loan events
    function beforeAllocate(address caller, TermKey memory termKey, LoanKey memory loanKey, AllocateParams memory params, bytes calldata hookData) external;
    function afterAllocate(address caller, TermKey memory termKey, LoanKey memory loanKey, AllocateParams memory params, bytes calldata hookData) external;
    function beforeRepay(address caller, TermKey memory termKey, LoanKey memory loanKey, RepayParams memory params, bytes calldata hookData) external;
    function afterRepay(address caller, TermKey memory termKey, LoanKey memory loanKey, RepayParams memory params, bytes calldata hookData) external;
}
```

***

**Access Control** — Whitelist addresses, require KYC

**Protocol Integration** — Connect to Aave, Compound, etc.

**Custom Logic** — Rate limiting, timelocks, custom fees

***

**Built-in hooks:** P2P (manual loan approval), AaveV3 (idle capital optimization), Timelock (delayed execution)

***

* Implement the interface above
* All functions are optional
* Reverting blocks the operation
* Reference deployed contracts for implementation details


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stormbit.finance/developers/building-hooks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
